/*
 * Clase principal del programa.
 * Implementa los constructores y metodos esenciales que permiten el inicio del
 * programa, asi como la interaccion entre todas las clases.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-24
 */

#include <iostream>			// Biblioteca para operaciones de entrada y salida
#include "MyWorld.h"		// Biblioteca de cabecera para el uso del mundo simulado
#include "Robot.h"			// Biblioteca de cabecera para uso de robots
#include "Vector2D.h"		// Biblioteca de cabecera para el uso de vectores
using namespace std;		// Incluye espacio de nombres para palabras reservadas

int main(){
	double deltaTime = 0.1;				// [s]
	MyWorld world;

	Vector2D position(0,0);       		// [m]
	Vector2D velocity(0.5,0.0);   		// [m/s]

	Robot* robot = new Robot(position, velocity);	// Robot(position, velocity);

	world.setRobot(robot);				// setea robot en mundo simulado
	world.printStateDescription();
	world.simulate(deltaTime, 0.5);  	// delta time[s], tiempo de simulacion total [s].
	robot->turnLeft();					// giro a la izquierda
	world.simulate(deltaTime, 1);    	// delta time[s], tiempo de simulacion total [s].
	robot->turnRight();					// giro a la derecha
	world.simulate(deltaTime, 1.5);  	// delta time[s], tiempo de simulacion total [s].
	robot->turnRight();					// giro a la derecha
	world.simulate(deltaTime, 2);    	// delta time[s], tiempo de simulacion total [s].

	return 0;
}
