/**
 * Implementa los constructores y metodos esenciales que permiten el uso de
 * un vector con coordenadas (X,Y) en el plano cartesiano.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-24
*/

#include "Vector2D.h"		/* Incluye libreria de cabecera que define
							 * los constructores y metodos a implementar */

Vector2D Vector2D::turnLeft() {
	return Vector2D(_y, -_x);
	/* Metodo que implementa el giro a la izquierda */
}

Vector2D Vector2D::turnRight() {
	return Vector2D(-_y, _x);
	/* Metodo que implementa el giro a la derecha */
}

string Vector2D::getDescription(){
    return "x,\ty";
    /* Metodo que imprime el titulo de las variables */
}

string Vector2D::toString(){
	ostringstream sx;
	sx << _x;
	ostringstream sy;
	sy << _y;
    return sx.str() + ",\t" + sy.str();
    /* Metodo que imprime las coordenadas (X,Y) en tiempo de simulacion */
}

Vector2D Vector2D::operator+(Vector2D plus){
	return Vector2D(this->_x + plus.getX(), this->_y + plus.getY());
	/* Metodo que implementa la suma de vectores */
}

Vector2D Vector2D::operator-(Vector2D minus){
	return Vector2D(this->_x - minus.getX(), this->_y - minus.getY());
	/* Metodo que implementa la resta de vectores */
}

Vector2D Vector2D::operator*(double factor){
	return Vector2D(factor*(this->_x), factor*(this->_y));
	/* Metodo que implementa el producto escalar de vectores */
}

void Vector2D::operator=(Vector2D equal){
	try{
		this->_x = equal.getX();
		this->_y = equal.getY();
	}catch(int e){
		_x = 0;
		_y = 0;
	}
	/* Metodo que arregla casos para valores (X,Y) iguales */
}
