/*
 * Clase que define las caracteristicas del laberinto.
 * Permite rotar un archivo pbm, creando un nuevo archivo de igual extension.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-21
 */

#ifndef MAZE_H_			// Comprueba si la etiqueta no esta definida
#define MAZE_H_			// Crea una bandera en tiempo de compilacion

#include <iostream>		// Biblioteca para las operaciones de entrada y salida
#include <fstream>		// Biblioteca para las operaciones con archivos
using namespace std;	// Incluye el espacio de nombres para palabras reservadas

class Maze{
	public:
		/* Constructores y metodos */
		Maze(ifstream& data);
		void dim();
		void rotate();
		void write(ofstream& rotate);

	private:
		/* Declaracion de variables */
		bool** _array;
		int _width, _height;
};

#endif 		/* Codigo se incluye en el paquete
			 * que se envia al compilador hasta aqui */
