/*
 * Clase principal del programa.
 * Implementa los constructores y metodos esenciales que permiten el inicio del
 * programa, asi como la interaccion entre todas las clases.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-21
 */

#include <iostream>			// Biblioteca para las operaciones de entrada y salida
#include <fstream>			// Biblioteca para el tratamiendo de archivos
#include <sstream>			// Biblioteca para utilizar cadenas de caracteres
#include "Maze.h"			// Biblioteca de cabecera para el uso del laberinto
using namespace std;		// Incluye espacio de nombres para palabras reservadas

int main(int argc, char* argv[]){
	ifstream maze_in;					// Laberinto original
	ofstream maze_out;					// Laberinto rotado

	if(argc != 3) {
	    cout << "Usage: ./Stage2 <pbm input file> <pbm output file>\n" << endl;
	    return 1;
	}

	maze_in.open(argv[1]);		// maze_in.open("maze_in.pbm", ios::in);
	if(maze_in.fail()){
		cout << "Error al abrir el archivo " << argv[1] << endl;
		return 1;
	}

	maze_out.open(argv[2]);		// maze_out.open("maze_out.pbm");
	if(maze_out.fail()){
		cout << "Error al abrir el archivo " << argv[2] << endl;
		return 1;
	}

	Maze maze(maze_in);			// Incluye el laberinto original
	maze.rotate();				// Rota el laberinto
	maze.write(maze_out);		// Escribe el laberinto rotado

	maze_in.close();			// Cierra maze_in.pbm
	maze_out.close();			// Cierra maze_out.pbm
	return 0;
}
