/*
 * Implementa los constructores y metodos que permiten el uso de sensores.
 * Se recuerda que estos van empotrados al robot.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 1.0
 * Since: 2018-07-21
*/

#include "DistanceSensor.h"		// Biblioteca de cabecera para uso de sensores
#include "MyWorld.h"			// Biblioteca de cabecera para incluir el mundo simulado
#include "Robot.h"				// Biblioteca de cabecera para definicio y uso de robots

DistanceSensor::DistanceSensor(Vector2D direction, double sensorRange, MyWorld* world, Robot* robot) {
	_direction = direction;
	_world = world;
	_robot = robot;
	_sensorRange = sensorRange;
	/* Metodo que instancia los sensores que tendra el robot */
}


bool DistanceSensor::senseWall() {
	double dx = _direction.getX() * _sensorRange + _robot->getPosition().getX();
	double dy = _direction.getY() * _sensorRange + _robot->getPosition().getY();
	return _world->isThere_a_wall((int) dx, (int) dy);
	/* Metodo que se encarga de detectar las paredes cercanas al robot */
}
