/*
 * Clase que define las caracteristicas de los sensores a utilizar.
 * Implemnte los constructores y metodos necesarios que permiten empotrar
 * sensores al robot, calcular y medir distancias, entre otros.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
*/

#ifndef DISTANCESENSOR_H_		// Comprueba si la etiqueta no esta definida
#define DISTANCESENSOR_H_		// Crea una bandera en tiempo de compilacion

#include "Vector2D.h"		// Biblioteca de cabecera que permite usar robots
#include <math.h>			// Biblioteca para utilizar operadores matematicos
using namespace std;		// Incluye espacio de nombres para palabras reservadas

class MyWorld;		// Declaracion directa del mundo simulado para generar espacio en memoria
class Robot;		// Declaracion directa del robot para generar espacio en memoria

class DistanceSensor {
	public:
	/* Constructores y metodos */
		DistanceSensor(): _direction(Vector2D()), _world(NULL), _robot(NULL), _sensorRange(0) {}
		DistanceSensor(Vector2D direction, double sensorRange, MyWorld* world, Robot* robot);
		void turnLeft() {_direction = _direction.turnLeft();}
		void turnRight() {_direction = _direction.turnRight();}
		bool senseWall();
		double getSensorRange() {return _sensorRange;}

	private:
	/* Definicion de variables */
		Vector2D _direction;
		MyWorld* _world;
		Robot* _robot;
		double _sensorRange;
};

#endif 		/* Codigo se incluye en el paquete
	 	 	 * que se envia al compilador hasta aqui */
