/*
 * Implementa los constructores y metodos que permiten obtener la informacion de
 * los parametros de inicio desde el archivo de extension pbm.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
 */

#include "DocumentedMaze.h"		// Biblioteca de cabecera para obtener informaci�n del laberinto
#include <limits>				// Biblioteca para funciones que definen limites
using namespace std;			// Incluye el espacio de nombres para palabras reservadas

DocumentedMaze::DocumentedMaze() : Maze(){
	_entrance = Vector2D();
	_direction = Vector2D();
	_exit = Vector2D();
	_exitRadius = 0;
	/* Constructor que obtiene los valores de inicio de la simulacion */
}

DocumentedMaze::DocumentedMaze(ifstream& maze) : Maze(maze){
	double x, y, dx, dy, fx, fy, r;
	// Llama al constructor de la clase padre y luego se vuelve al inicio del archivo

	maze.clear();
	maze.seekg(0, maze.beg);
	maze.ignore(numeric_limits<streamsize>::max(), '\n');
	maze.ignore(numeric_limits<streamsize>::max(), ' ');

	maze >> x >> y >> dx >> dy >> fx >> fy >> r;

	_entrance = Vector2D(x, y);
	_direction = Vector2D(dx, dy);
	_exit = Vector2D(fx, fy);
	_exitRadius = r;
	/* Metodo que obtiene los valores desde el archivo pbm del laberinto */
}

void DocumentedMaze::setEntrance(double x, double y){
	_entrance.setTo(x,y);
	/* Metodo que setea la posicion de entrada del laberinto */
}

void DocumentedMaze::setDirection(double x, double y){
	_direction.setTo(x,y);
	/* Metodo que setea la direccion de inicio del robot */
}

void DocumentedMaze::setExit(double x, double y){
	_exit.setTo(x,y);
	/* Metodo que setea la posicion de salida al laberinto */
}

void DocumentedMaze::setExitRadius(double radius){
	_exitRadius = radius;
	/* Metodo que setea el radio de salida del laberinto */
}

Vector2D DocumentedMaze::getEntrance(){
	return _entrance;
	/* Metodo que retorna la entrada del laberinto */
}

Vector2D DocumentedMaze::getDirection(){
	return _direction;
	/* Metodo que retona la direccion de inicio del robot */
}

Vector2D DocumentedMaze::getExit(){
	return _exit;
	/* Metodo que retorna la salida del laberinto */
}

double DocumentedMaze::getExitRadius(){
	return _exitRadius;
	/* Metodo que retorna el radio de salida del laberinto */
}
