/*
 * Implementa los constructores y metodos que permiten desarrollar el algoritmo
 * de movimiento pegado a la pared izquierda para recorrer el laberinto.
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
 */

#include "MyPilot.h"		// Biblioteca que extiende de pilot para definir otro algoritmo
using namespace std;		// Incluye espacio de nombres para palabras reservadas

MyPilot::MyPilot(Robot* robot) : Pilot(robot){
	_robot = robot;
	_robotFront = robot->getFrontSensor();
	_robotLeft = robot->getLeftSensor();
	_robotRight = robot->getRightSensor();
	/* Constructor que inicia las variables a utilizar para el piloto */
}

void MyPilot::setCourseLeft(){
	bool wallRight, wallLeft, wallFront, wallLeftFront, lost;

	bool rightSensor = _robotRight->senseWall();
	bool leftSensor = _robotLeft->senseWall();
	bool frontSensor = _robotFront->senseWall();

	lost = (!(rightSensor) && !(frontSensor) && !(leftSensor));
	wallRight = ((rightSensor) && !(frontSensor) && !(leftSensor));
	wallLeft = (!(rightSensor) && !(frontSensor) && (leftSensor));
	wallFront = (!(rightSensor) && (frontSensor) && !(leftSensor));
	wallLeftFront = (!(rightSensor) && (frontSensor) && (leftSensor));

	if(_robot->getPosition().getX() == _robotRight->getSensorRange()){
		_state = 0;
	}else if(wallLeft){
		_state = 0;
	}else if(wallRight || wallFront || wallLeftFront){
		_state = 0;
		_robot->turnRight();
	}else if(lost){
		if(_state == 0)
			_robot->turnLeft();		// giro a la derecha si esta perdido
		else if(_state == 1)
			_state = 1; 			// Solucion parche para hacer nada
		else if(_state == 2)
			_robot->turnRight();	// giro a la izquierda si esta perdido
		else if(_state == 3)
			_state = 3;				// Solucion parche para hacer nada
		else{
			cout << "Caso no contado en perdido" << endl;
			exit(1);
		}
		_state = (_state + 1) % 4;
	}else{
		_robot->getPosition().setTo(225, 190);
		cout << "Bug" << endl;
	}
	/* Metodo que permite recorrer el laberinto pegado a la pared izquierda */
}
