/*
 * Implementa los metodos y constructores necesarios para determinar el
 * algoritmo de movimiento al interior del laberinto (pegado a la pared derecha).
 *
 * Autor: Matias Contreras, Francisco Frez, Damian Quiroz.
 * Version: 2.0
 * Since: 2018-07-29
 */

#include "Pilot.h"		// Biblioteca de cabecera que define los metodos de Pilot
using namespace std;	// Incluye espacio de nombres para palabras reservadas

Pilot::Pilot(Robot* robot){
	this->_robot = robot;
	this->_robotFront = robot->getFrontSensor();
	this->_robotLeft = robot->getLeftSensor();
	this->_robotRight = robot->getRightSensor();
	/* Constructor que inicia las variables a utilizar para el piloto */
}

void Pilot::setCourseRight(){
	bool wallRight, wallLeft, wallFront, wallRightFront, lost;

	bool rightSensor = _robotRight->senseWall();
	bool leftSensor = _robotLeft->senseWall();
	bool frontSensor = _robotFront->senseWall();

	lost = (!(rightSensor) && !(frontSensor) && !(leftSensor));
	wallRight = ((rightSensor) && !(frontSensor) && !(leftSensor));
	wallLeft = (!(rightSensor) && !(frontSensor) && (leftSensor));
	wallFront = (!(rightSensor) && (frontSensor) && !(leftSensor));
	wallRightFront = ((rightSensor) && (frontSensor) && !(leftSensor));

	if(_robot->getPosition().getX() == _robotRight->getSensorRange()){
		_state = 0;
	}else if(wallRight){
	    _state = 0;
	 }else if(wallLeft || wallFront || wallRightFront){
	    _state = 0;
	    _robot->turnLeft();
	 }else if(lost){
		 if(_state == 0)
			 _robot->turnRight();	// giro a la derecha si esta perdido
		 else if(_state == 1)
			 _state = 1; 			// Solucion parche para hacer nada
		 else if(_state == 2)
			 _robot->turnLeft();	// giro a la izquierda
		 else if(_state == 3)
			 _state = 3;			// Solucion parche para hacer nada
		 else{
			 cout << "Caso no contado en perdido" << endl;
			 exit(1);
	    }
	    _state = (_state + 1) % 4;
	 }else{
	    cout << "Bug" << endl;
	 }
	/* Metodo que permite recorrer el laberinto pegado a la pared derecha */
}
